Python: Excepciones

Las excepciones son errores detectados por Python durante la ejecución del programa. Cuando el intérprete se encuentra con una situación excepcional, como el intentar dividir un número entre 0 o el intentar acceder a un archivo que no existe, este genera o lanza una excepción, informando al usuario de que existe algún problema.

Si la excepción no se captura el flujo de ejecución se interrumpe y se muestra la información asociada a la excepción en la consola de forma que el programador pueda solucionar el problema.

Veamos un pequeño programa que lanzaría una excepción al intentar dividir 1 entre 0.

def division(a, b):
    return a / b

def calcular():
    division(1, 0)

calcular()

Si lo ejecutamos obtendremos el siguiente mensaje de error:

$ python ejemplo.py
Traceback (most recent call last):
File “ejemplo.py”, line 7, in
calcular()
File “ejemplo.py”, line 5, in calcular
division(1, 0)
File “ejemplo.py”, line 2, in division
a / b
ZeroDivisionError: integer division or modulo by zero

Lo primero que se muestra es el trazado de pila o traceback, que consiste en una lista con las llamadas que provocaron la excepción. Como vemos en el trazado de pila, el error estuvo causado por la llamada a calcular() de la línea 7, que a su vez llama a division(1, 0) en la línea 5 y en última instancia por la ejecución de la sentencia a / b de la línea 2 de division.

A continuación vemos el tipo de la excepción, ZeroDivionError, junto a una descripción del error: “integer division or modulo by zero” (módulo o división entera entre cero).

En Python se utiliza una construcción tryexcept para capturar y tratar las excepciones. El bloque try (intentar) define el fragmento de código en el que creemos que podría producirse una excepción. El bloque except (excepción) permite indicar el tratamiento que se llevará a cabo de producirse dicha excepción. Muchas veces nuestro tratamiento de la excepción consistirá simplemente en imprimir un mensaje más amigable para el usuario, otras veces nos interesará registrar los errores y de vez en cuando podremos establecer una estrategia de resolución del problema.

En el siguiente ejemplo intentamos crear un objeto f de tipo fichero. De no existir el archivo pasado como parámetro, se lanza una excepción de tipo IOError, que capturamos gracias a nuestro tryexcept.

try:
    f = file("archivo.txt")
except:
    print "El archivo no existe"

Python permite utilizar varios except para un solo bloque try, de forma que podamos dar un tratamiento distinto a la excepción dependiendo del tipo de excepción de la que se trate. Esto es una buena práctica, y es tan sencillo como indicar el nombre del tipo a continuación del except.

try:
    num = int("3a")
    print no_existe
except NameError:
    print "La variable no existe"
except ValueError:
    print "El valor no es un numero"

Cuando se lanza una excepción en el bloque try, se busca en cada una de las clausulas except un manejador adecuado para el tipo de error que se produjo. En caso de que no se encuentre, se propaga la excepción.

Además podemos hacer que un mismo except sirva para tratar más de una excepción usando una tupla para listar los tipos de error que queremos que trate el bloque:

try:
    num = int("3a")
    print no_existe
except (NameError, ValueError):
    print "Ocurrio un error"

La construcción tryexcept puede contar además con una clausula else, que define un fragmento de código a ejecutar sólo si no se ha producido ninguna excepción en el try.

try:
    num = 33
except:
    print "Hubo un error!"
else:
    print "Todo esta bien"

También existe una clausula finally que se ejecuta siempre, se produzca o no una excepción. Esta clausula se suele utilizar, entre otras cosas, para tareas de limpieza.

try:
    z = x / y
except ZeroDivisionError:
    print "Division por cero"
finally:
    print "Limpiando..."

También es interesante comentar que como programadores podemos crear y lanzar nuestras propias excepciones. Basta crear una clase que herede de Exception o cualquiera de sus hijas y lanzarla con raise.

class MiError(Exception):
    def __init__(self, valor):
        self.valor = valor

    def __str__(self):
        return "Error " + str(self.valor)

try:
    if resultado > 20:
        raise MiError(33)
except MiError, e:
    print e

Por último, a continuación se listan las excepciones disponibles por defecto, así como la clase de la que deriva cada una de ellas entre paréntesis.

  • BaseException: Clase de la que heredan todas las excepciones.
  • Exception(BaseException): Super clase de todas las excepciones que no sean de salida.
  • GeneratorExit(Exception): Se pide que se salga de un generador.
  • StandarError(Exception): Clase base para todas las excepciones que no tengan que ver con salir del intérprete.
  • ArithmeticError(StandardError): Clase base para los errores aritméticos.
  • FloatingPointError(ArithmeticError): Error en una operación de coma flotante.
  • OverflowError(ArithmeticError): Resultado demasiado grande para poder representarse.
  • ZeroDivisionError(ArithmeticError): Lanzada cuando el segundo argumento de una operación de división o módulo era 0
  • AssertionError(StandardError): Falló la condición de un estamento assert.
  • AttributeError(StandardError): No se encontró el atributo.
  • EOFError(StandardError): Se intentó leer más allá del final de fichero.
  • EnvironmentError(StandardError): Clase padre de los errores relacionados con la entrada/salida.
  • IOError(EnvironmentError): Error en una operación de entrada/salida.
  • OSError(EnvironmentError): Error en una llamada a sistema.
  • WindowsError(OSError): Error en una llamada a sistema en Windows.
  • ImportError(StandardError): No se encuentra el módulo o el elemento del módulo que se quería importar.
  • LookupError(StandardError): Clase padre de los errores de acceso.
  • IndexError(LookupError): El índice de la secuencia está fuera del rango posible.
  • KeyError(LookupError): La clave no existe.
  • MemoryError(StandardError): No queda memoria suficiente.
  • NameError(StandardError): No se encontró ningún elemento con ese nombre.
  • UnboundLocalError(NameError): El nombre no está asociado a ninguna variable.
  • ReferenceError(StandardError): El objeto no tiene ninguna referencia fuerte apuntando hacia él.
  • RuntimeError(StandardError): Error en tiempo de ejecución no especificado.
  • NotImplementedError(RuntimeError): Ese método o función no está implementado.
  • SyntaxError(StandardError): Clase padre para los errores sintácticos.
  • IndentationError(SyntaxError): Error en la indentación del archivo.
  • TabError(IndentationError): Error debido a la mezcla de espacios y tabuladores.
  • SystemError(StandardError): Error interno del intérprete.
  • TypeError(StandardError): Tipo de argumento no apropiado.
  • ValueError(StandardError): Valor del argumento no apropiado.
  • UnicodeError(ValueError): Clase padre para los errores relacionados con unicode.
  • UnicodeDecodeError(UnicodeError): Error de decodificación unicode.
  • UnicodeEncodeError(UnicodeError): Error de codificación unicode.
  • UnicodeTranslateError(UnicodeError): Error de traducción unicode.
  • StopIteration(Exception): Se utiliza para indicar el final del iterador.
  • Warning(Exception): Clase padre para los avisos.
  • DeprecationWarning(Warning): Clase padre para avisos sobre características obsoletas.
  • FutureWarning(Warning): Aviso. La semántica de la construcción cambiará en un futuro.
  • ImportWarning(Warning): Aviso sobre posibles errores a la hora de importar.
  • PendingDeprecationWarning(Warning): Aviso sobre características que se marcarán como obsoletas en un futuro próximo.
  • RuntimeWarning(Warning): Aviso sobre comportmaientos dudosos en tiempo de ejecución.
  • SyntaxWarning(Warning): Aviso sobre sintaxis dudosa.
  • UnicodeWarning(Warning): Aviso sobre problemas relacionados con Unicode, sobre todo con problemas de conversión.
  • UserWarning(Warning): Clase padre para avisos creados por el programador.
  • KeyboardInterrupt(BaseException): El programa fué interrumpido por el usuario.
  • SystemExit(BaseException): Petición del intérprete para terminar la ejecución.

4 thoughts on “Python: Excepciones

  1. Hola me parecio muy interesante tu página espero puedas seguir publicando mas cosas para seguir aprendiendo de ti, Felicitaciones por el nuevo año, espero que sea el mejor año para ti. Chao Besos. Respondeme a esta dirección. yasmary.diaz@gobart.co.cu. Soy una muchacha q busca amistades.

    1. Hola Yasmary lo propio para ti por el año nuevo. Si hasta yo espero seguir publicando cosas para compartir conocimientos y amistades. Gracias por escribir y que bueno que te parecio interesante el blog … saludos

  2. Que edad tienes?, disculpa mi atrevimiento pero me pareció apropiado tu vocabulario es muy poco común en los jovenes hoy en dia de donde, por eso admiro las personas como tu, y eso q no te conozco pero por la forme de expresarte me pareces buena persona, me gustaria ser tu amiga,

    1. Yasmary tengo 29 años y mi vocabulario bueno te diré que soy un jóven normal pero trato de ajustarme a los entornos, quise que este blog fuese algo serio y para ello necesito que los lectores vean en mi alguien serio y con un trabajo dedicado. Tal parece que lo he logrado si ese fue tu parecer. Y tranquila sin problemas amigos !!! Saludos y sigue comentando.

Deja un comentario

Tu dirección de correo electrónico no será publicada. Los campos obligatorios están marcados con *